﻿@model StarterProjectV2.ViewModels.PostViewModel

@{
    /**/

    ViewData["Title"] = "Post View";
}
@section HEADERJS{
    <script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/1/jquery.min.js"></script>
}

@section FOOTERJS{
    <script src="~/Content/vendors/js/toastr.min.js"></script>
    <script src="~/Content/vendors/js/coreui.min.js"></script>
}
@section PAGETITLE{
    Post View
}


<h2 class="text-center" style="color:indianred">@ViewData["Title"]</h2>
@if (Model.Approval == true)
{
    <div class="card m-0">
        <div class="card-header">
            <strong>@Model.OwnersName</strong> has posted at @Model.Time on <strong>@Model.PostHeader</strong> topic.
            <span class="float-right">Approved At @Model.ApproveTime</span>
        </div>

        <div class="card-body">
            <span style="font-size:large" id="@Model.PostId">@Model.PostText</span>
        </div>
        <div class="card-footer">
            @{
                var OwnerId = Session[SessionKeys.USERNAME].ToString();
            }
            @{
                var flg = Model.FlagLike;
                if (flg == true)
                {
                    <button type="button" class="btn btn-green mr-1 active btn-sm" data-toggle="tooltip" data-placement="bottom" title="Liked" id="@Model.PostId" onclick="UnLike('@Model.PostId')">
                        <i class="fa fa-thumbs-up"></i>
                    </button>
                }
                else
                {
                    <button type="button" class="btn btn-primary mr-1 btn-sm" data-toggle="tooltip" data-placement="bottom" title="Like" id="@Model.PostId" onclick="Like('@Model.PostId')">
                        <i class="fa fa-thumbs-up"></i>
                    </button>
                }
                <button type="button" class="btn btn-sm btn-primary mr-1" data-placement="bottom" title="Comment" data-toggle="modal" data-target="#comment-modal" onclick="onclickComment('@Model.PostId')"><i class="icon-bubble"></i></button>
                if (OwnerId == Model.PostedBy)
                {
                    <button type="button" class="btn btn-sm btn-primary mr-1" data-placement="bottom" title="Edit" data-toggle="modal" data-target="#edit-modal" onclick="onClickEdit('@Model.PostId', '@Model.PostText.Replace("'", "\\'").Replace("\n", " ")','@Model.PostHeader.Replace("'", "\\'").Replace("\n", " ")')"><i class="icon-notebook"></i></button>
                    <button type="button" class="btn btn-sm btn-danger mr-1" data-placement="bottom" title="Delete" data-toggle="modal" data-target="#delete-modal" onclick="onclickDelete('@Model.PostId')">
                        <i class="icon-trash"></i>
                    </button>
                }
            }
            <span class=" float-right" style="font-size:medium"><strong>@Model.NoOfLikes Likes, @Model.NoOfComments Comments</strong></span>
        </div>
        <div class="modal fade" id="edit-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="editModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <input type="text" value="" id="edit-post-id" style="display: none" />
                    <div class="modal-body">
                        <div class="form-group row">
                            <label class="col-lg-2 col-md-2 col-sm-2 col-form-label" for="text-input">Title</label>
                            <div class="col">
                                <textarea class="form-control" type="text" id="edit-post-title"></textarea>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label class="col-lg-2 col-md-2 col-sm-2 col-form-label" for="text-input">Post</label>
                            <div class="col">
                                <textarea class="form-control" type="text" id="edit-post-text"></textarea>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        <button type="submit" class="btn btn-success" data-dismiss="modal" id="approve-all-confirmed" onclick="Edit()">Edit</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="comment-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <input type="text" value="" id="post-id" style="display: none" />
                    <div class="modal-body">
                        <div class="form-group row">
                            <label class="col-lg-4 col-md-4 col-sm-4 col-form-label" for="text-input">Comment</label>
                            <div class="col">
                                <textarea class="form-control" type="text" id="comment-text"></textarea>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        <button type="submit" class="btn btn-success" data-dismiss="modal" id="approve-all-confirmed" onclick="Comment()">Comment</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="delete-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="deleteModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <input type="text" value="" id="delete-post-id" style="display: none" />
                    @* <div class="modal-body"> *@
                    @*     <div class="form-group row"> *@
                    @*         <span *@
                    @*     </div> *@
                    @* </div> *@
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        <button type="submit" class="btn btn-success" data-dismiss="modal" id="approve-all-confirmed" onclick="Delete()">Delete</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
}
else
{
    <div class="card">
        <div class="card-header">
            <strong>@Model.OwnersName</strong> has posted at @Model.Time.
        </div>
        <div class="card-body">
            <h5>The Post is waiting for approval from administration.</h5>
        </div>
    </div>
}


@foreach (var comment in Model.Comments)
{
    if (comment.Comment.Approval == true)
    {
        var SessionOwnerId = Session[SessionKeys.USERNAME].ToString();
        var CommentFlg = (comment.Comment.CommentorId == SessionOwnerId) ? true : false;
        <div class="card ml-5 m-0">
            <div class="card-header">
                <strong>@comment.CommentorName</strong> has commented at @comment.Comment.CommentTime.
            </div>
            <div class="card-body">
                <span style="font-size:medium" class="linkify_comments" id="@comment.Comment.CommentId">@comment.Comment.CommentText</span>
            </div>
            @{
                if (CommentFlg == true)
                {
                    @*                                         <div class="card-footer"> *@
                    <div class="form-group row ml-3 mt-0">
                        <button type="button" class="btn btn-primary m-1 btn-sm" data-placement="bottom" title="Edit" data-toggle="modal" data-target="#comment-edit-modal" onclick="onclickCommentEdit('@comment.Comment.CommentId', '@comment.Comment.CommentText.Replace("'", "\\'").Replace("\n", " ")')"><i class="icon-notebook"></i></button>
                        <button type="button" class="btn btn-danger m-1 btn-sm" data-placement="bottom" title="Delete" data-toggle="modal" data-target="#comment-delete-modal" onclick="onclickCommentDelete('@comment.Comment.CommentId')">
                            <i class="icon-trash"></i>
                        </button>
                    </div>
                    //                                        </div>
                }
            }
        </div>
        <div class="modal fade" id="comment-edit-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="commentEditModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <input type="text" value="" id="edit-comment-id" style="display: none" />
                    <div class="modal-body">
                        <div class="form-group row">
                            <label class="col-lg-2 col-md-2 col-sm-2 col-form-label" for="text-input">Comment</label>
                            <div class="col">
                                <textarea class="form-control" type="text" id="edit-comment-text"></textarea>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        <button type="submit" class="btn btn-success" data-dismiss="modal" id="approve-all-confirmed" onclick="EditComment()">Edit</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="comment-delete-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="commentDeleteModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <input type="text" value="" id="delete-comment-id" style="display: none" />
                    @* <div class="modal-body"> *@
                    @*     <div class="form-group row"> *@
                    @*         <span *@
                    @*     </div> *@
                    @* </div> *@
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        <button type="submit" class="btn btn-success" data-dismiss="modal" id="approve-all-confirmed" onclick="CommentDelete()">Delete</button>
                    </div>
                </div>
            </div>
        </div>
    }
    else
    {
        <div class="card ml-5">
            <div class="card-header">
                <strong>@comment.CommentorName</strong> has commented at @comment.Comment.CommentTime.
            </div>
            <div class="card-body">
                <h5>The comment is waiting for approval from administration.</h5>
            </div>
        </div>
    }
}

<script>
    //alert(Ids.length);
    var urlRegex = /(([a-z]+:\/\/)?(([a-z0-9\-]+\.)+([a-z]{2}|aero|arpa|biz|com|coop|edu|gov|info|int|jobs|mil|museum|name|nato|net|org|pro|travel|local|internal))(:[0-9]{1,5})?(\/[a-z0-9_\-\.~]+)*(\/([a-z0-9_\-\.]*)(\?[a-z0-9+_\-\.%=&amp;]*)?)?(#[a-zA-Z0-9!$&'()*+.=-_~:@@/?]*)?)(\s+|$)/gi;
    ////    //var urlRegex = www.google.com;
    //        //alert('hey');

    function linkifyJs(text) {
        return text.replace(urlRegex, function (url) {
            return '<a href="' + url + '" target="_blank">' + url + '</a>';
        });
    }
</script>
<script>
    var post_Id = "@Model.PostId";
    //alert(ids);
    var text = $('#' + post_Id).text();
    var res = linkifyJs(text);
    //alert(text);
    $('#' + post_Id).html(res);
</script>
<script>
    var ids = $('.linkify_comments').map(function () {
        return this.id
    }).get();
    //alert(ids);
    for (var i = 0; i < ids.length; i++) {
        var text = $('#' + ids[i]).text();
        var res = linkifyJs(text);
        //alert(text);
        $('#' + ids[i]).html(res);
    }
</script>


<script>

    $(function () {
        $('[data-toggle="tooltip"]').tooltip();
        $('[data-toggle="modal"]').tooltip();
    })
</script>
<script>
    //    Comment on Model.Posts[idx].PostId
    function onClickEdit(x, y, z) {
        //        alert('dfdfd');
        $("#editModalLabel").text('Edit the ' + x);
        $("#edit-post-id").val(x);
        $("#edit-post-text").val(y);
        $("#edit-post-title").val(z);
    }
</script>
<script>
    function EditComment() {
        var post_id = "@Model.PostId";
        var CommentText = $("#edit-comment-text").val().replace('/\r\n/g', '\n');
        var myModel = {
            CommentId: $("#edit-comment-id").val(),
            CommentText: CommentText,
        };
        if (CommentText.length === 0) {
            //                alert('Nope');
            toastr.error('Please, do not make the comment field empty.',
                'Error!!!!',
                {
                    closeButton: true,
                    progressBar: true,
                });
        } else {
            $.ajax({
                context: this,
                type: 'post',
                url: '../Chatting/editingAComment/',
                data: myModel,
                success: function (result) {
                    window.location = '../Chatting/PostView?postId='+post_id;
                },
                error: function () { }
            });
        }


    }
</script>
<script>
    //    Comment on Model.Posts[idx].PostId
    function onclickCommentEdit(x, y) {
        $("#commentEditModalLabel").text('Edit the Comment: ' + x);
        $("#edit-comment-id").val(x);
        $("#edit-comment-text").val(y);
    }
</script>
<script>
    function Edit() {
        var post_id = $("#edit-post-id").val();
        var PostText = $("#edit-post-text").val().replace('/\r\n/g', '\n');
        var PostHeader = $('#edit-post-title').val().replace('/\r\n/g', '\n');
        var myModel = {
            PostId: $("#edit-post-id").val(),
            PostTitle: PostHeader,
            PostText: PostText,
        };
        if (PostHeader.length === 0 || PostText.length === 0) {
            //                alert('Nope');
            toastr.error('Please, do not make any field empty.',
                'Error!!!!',
                {
                    closeButton: true,
                    progressBar: true,
                });
        } else {
            $.ajax({
                context: this,
                type: 'post',
                url: '../Chatting/editingAPost/',
                data: myModel,
                success: function (result) {
                    window.location = '../Chatting/PostView?postId=' + post_id;
                },
                error: function () { }
            });
        }

    }
</script>
<script>
    function Delete() {
        var myModel = {
            PostId: $("#delete-post-id").val(),
        };
        $.ajax({
            context: this,
            type: 'post',
            url: '../Chatting/deletingAPost/',
            data: myModel,
            success: function (result) {
                window.location = '../Chatting/WallPage';
            },
            error: function () { }
        });
    }
</script>
<script>
    function CommentDelete() {
        var post_id = "@Model.PostId";
        var myModel = {
            CommentId: $("#delete-comment-id").val(),
        };
        $.ajax({
            context: this,
            type: 'post',
            url: '../Chatting/deletingAComment/',
            data: myModel,
            success: function (result) {
                window.location = '../Chatting/PostView?postId=' + post_id;
            },
            error: function () { }
        });
    }
</script>
<script>
    //    Comment on Model.Posts[idx].PostId
    function onclickComment(x) {
        $("#exampleModalLabel").text('Comment on ' + x);
        $("#post-id").val(x);
    }
</script>

<script>
    //    Comment on Model.Posts[idx].PostId
    function onclickDelete(x) {
        $("#deleteModalLabel").text('Are you sure you want to delete ' + x + ' ?');
        $("#delete-post-id").val(x);
    }
</script>
<script>
    //onclickCommentDelete
    function onclickCommentDelete(x) {
        $("#commentDeleteModalLabel").text('Are you sure you want to delete the comment?');
        $("#delete-comment-id").val(x);
    }
</script>
<script>
    function Like(x) {
        var myModel = {
            PostId: x,
        };
        $.ajax({
            context: this,
            type: 'post',
            url: '../Chatting/gettingALike/',
            data: myModel,
            success: function (result) {
                window.location = '../Chatting/PostView?postId=' + x;
            },
            error: function () { }
        });
    }
</script>
<script>
    function UnLike(x) {
        var myModel = {
            PostId: x,
        };
        $.ajax({
            context: this,
            type: 'post',
            url: '../Chatting/gettingAnUnlike/',
            data: myModel,
            success: function (result) {
                window.location = '../Chatting/PostView?postId=' + x;
            },
            error: function () { }
        });
    }
</script>
<script>
    function Comment() {
        var post_id = $("#post-id").val();
        var CommentText = $("#comment-text").val().replace('/\r\n/g', '\n');
        var myModel = {
            PostId: $("#post-id").val(),
            CommentText: CommentText,
        }; if (CommentText.length === 0) {
            //                alert('Nope');
            toastr.error('Please, fill the comment field.',
                'Error!!!!',
                {
                    closeButton: true,
                    progressBar: true,
                });
        } else {
            $.ajax({
                context: this,
                type: 'post',
                url: '../Chatting/gettingAComment/',
                data: myModel,
                success: function (result) {
                    window.location = '../Chatting/PostView?postId=' + post_id;
                },
                error: function () { }
            });
        }

    }
</script>